diff --git a/gcc/tree-vect-slp.c b/gcc/tree-vect-slp.c
index 73aa227..99a8104 100644
--- a/gcc/tree-vect-slp.c
+++ b/gcc/tree-vect-slp.c
@@ -45,6 +45,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "vec-perm-indices.h"
 #include "gimple-fold.h"
 #include "internal-fn.h"
+#include "optimization-records.h"
 
 
 /* Recursively free the memory allocated for the SLP tree rooted at NODE.  */
@@ -349,9 +350,9 @@ again:
 
       if (!vect_is_simple_use (oprnd, vinfo, &def_stmt, &dt))
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      vect_location_writeln (OPT_RECORD_FAILURE,
 			       "Build SLP failed: can't analyze def for ");
 	      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, oprnd);
               dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -385,11 +386,11 @@ again:
 		  goto again;
 		}
 
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-				   "Build SLP failed: some of the stmts"
-				   " are in a pattern, and others are not ");
+		  vect_location_writeln (OPT_RECORD_FAILURE,
+					 "Build SLP failed: some of the stmts"
+					 " are in a pattern, and others are not ");
 		  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, oprnd);
                   dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
 		}
@@ -402,9 +403,9 @@ again:
 
           if (dt == vect_unknown_def_type)
             {
-              if (dump_enabled_p ())
-                dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-				 "Unsupported pattern.\n");
+              if (thing_enabled_p ())
+                vect_location_writeln (OPT_RECORD_FAILURE,
+				       "Unsupported pattern");
               return -1;
             }
 
@@ -415,8 +416,8 @@ again:
 	      break;
 
 	    default:
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
 				 "unsupported defining stmt:\n");
 	      return -1;
             }
@@ -457,8 +458,8 @@ again:
 		  goto again;
 		}
 
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
 				 "Build SLP failed: different types\n");
 
 	      return 1;
@@ -470,9 +471,9 @@ again:
 		  || !can_duplicate_and_interleave_p (stmts.length (),
 						      TYPE_MODE (type))))
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
 				   "Build SLP failed: invalid type of def "
 				   "for variable-length SLP ");
 		  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, oprnd);
@@ -497,9 +498,9 @@ again:
 
 	default:
 	  /* FORNOW: Not supported.  */
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      vect_location_writeln (OPT_RECORD_FAILURE,
 			       "Build SLP failed: illegal type of def ");
 	      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, oprnd);
               dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -516,9 +517,9 @@ again:
          we've committed to the operand order and can't swap it.  */
       if (STMT_VINFO_NUM_SLP_USES (vinfo_for_stmt (stmt)) != 0)
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      vect_location_writeln (OPT_RECORD_FAILURE,
 			       "Build SLP failed: cannot swap operands of "
 			       "shared stmt ");
 	      dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -552,9 +553,9 @@ again:
       else
 	swap_ssa_operands (stmt, gimple_assign_rhs1_ptr (stmt),
 			   gimple_assign_rhs2_ptr (stmt));
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "swapped operands to match def types in ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	}
@@ -577,9 +578,9 @@ vect_record_max_nunits (vec_info *vinfo, gimple *stmt, unsigned int group_size,
 {
   if (!vectype)
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 			   "Build SLP failed: unsupported data-type in ");
 	  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
 	  dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -596,9 +597,9 @@ vect_record_max_nunits (vec_info *vinfo, gimple *stmt, unsigned int group_size,
       && (!nunits.is_constant (&const_nunits)
 	  || const_nunits > group_size))
     {
-      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-		       "Build SLP failed: unrolling required "
-		       "in basic block SLP\n");
+      vect_location_writeln (OPT_RECORD_FAILURE,
+			     "Build SLP failed: unrolling required "
+			     "in basic block SLP");
       /* Fatal mismatch.  */
       return false;
     }
@@ -650,18 +651,18 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
       swap[i] = 0;
       matches[i] = false;
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location, "Build SLP for ");
+	  vect_location_writeln (OPT_RECORD_REMARK, "Build SLP for ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	}
 
       /* Fail to vectorize statements marked as unvectorizable.  */
       if (!STMT_VINFO_VECTORIZABLE (vinfo_for_stmt (stmt)))
         {
-          if (dump_enabled_p ())
+          if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+              vect_location_writeln (OPT_RECORD_FAILURE,
 			       "Build SLP failed: unvectorizable statement ");
               dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
             }
@@ -673,9 +674,9 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
       lhs = gimple_get_lhs (stmt);
       if (lhs == NULL_TREE)
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      vect_location_writeln (OPT_RECORD_FAILURE,
 			       "Build SLP failed: not GIMPLE_ASSIGN nor "
 			       "GIMPLE_CALL ");
 	      dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -704,9 +705,9 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	      || !gimple_call_nothrow_p (call_stmt)
 	      || gimple_call_chain (call_stmt))
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location, 
+		  vect_location_writeln (OPT_RECORD_FAILURE, 
 				   "Build SLP failed: unsupported call type ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
 				    call_stmt, 0);
@@ -745,8 +746,8 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 
 		  if (!optab)
 		    {
-		      if (dump_enabled_p ())
-			dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		      if (thing_enabled_p ())
+			vect_location_writeln (OPT_RECORD_FAILURE,
 					 "Build SLP failed: no optab.\n");
 		      /* Fatal mismatch.  */
 		      matches[0] = false;
@@ -755,8 +756,8 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 		  icode = (int) optab_handler (optab, vec_mode);
 		  if (icode == CODE_FOR_nothing)
 		    {
-		      if (dump_enabled_p ())
-			dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		      if (thing_enabled_p ())
+			vect_location_writeln (OPT_RECORD_FAILURE,
 					 "Build SLP failed: "
 					 "op not supported by target.\n");
 		      /* Fatal mismatch.  */
@@ -801,13 +802,13 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
                        || first_stmt_code == COMPONENT_REF
                        || first_stmt_code == MEM_REF)))
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location, 
+		  vect_location_writeln (OPT_RECORD_FAILURE, 
 				   "Build SLP failed: different operation "
 				   "in stmt ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
 				   "original stmt ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
 				    first_stmt, 0);
@@ -819,9 +820,9 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	  if (need_same_oprnds
 	      && !operand_equal_p (first_op1, gimple_assign_rhs2 (stmt), 0))
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location, 
+		  vect_location_writeln (OPT_RECORD_FAILURE, 
 				   "Build SLP failed: different shift "
 				   "arguments in ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -839,9 +840,9 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 		  || gimple_call_fntype (first_stmt)
 		     != gimple_call_fntype (stmt))
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    {
-		      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location, 
+		      vect_location_writeln (OPT_RECORD_FAILURE, 
 				       "Build SLP failed: different calls in ");
 		      dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
 					stmt, 0);
@@ -870,7 +871,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
                      chains in the same node.  */
                   if (prev_first_load != first_load)
                     {
-                      if (dump_enabled_p ())
+                      if (thing_enabled_p ())
                         {
                           dump_printf_loc (MSG_MISSED_OPTIMIZATION,
 					   vect_location, 
@@ -892,9 +893,9 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	  if (TREE_CODE_CLASS (rhs_code) == tcc_reference)
 	    {
 	      /* Not grouped load.  */
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location, 
+		  vect_location_writeln (OPT_RECORD_FAILURE, 
 				   "Build SLP failed: not grouped load ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
 		}
@@ -912,9 +913,9 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	      && TREE_CODE_CLASS (rhs_code) != tcc_comparison
 	      && rhs_code != CALL_EXPR)
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
 				   "Build SLP failed: operation");
 		  dump_printf (MSG_MISSED_OPTIMIZATION, " unsupported ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
@@ -950,9 +951,9 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 		swap[i] = 2;
 	      else
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    {
-		      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		      vect_location_writeln (OPT_RECORD_FAILURE,
 				       "Build SLP failed: different"
 				       " operation");
 		      dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -980,8 +981,8 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
       unsigned HOST_WIDE_INT count;
       if (!nunits.is_constant (&count))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "Build SLP failed: different operations "
 			     "not allowed with variable-length SLP.\n");
 	  return false;
@@ -1001,14 +1002,14 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	    if (gimple_assign_rhs_code (stmts[i]) == alt_stmt_code)
 	      {
 		matches[i] = false;
-		if (dump_enabled_p ())
+		if (thing_enabled_p ())
 		  {
-		    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		    vect_location_writeln (OPT_RECORD_FAILURE,
 				     "Build SLP failed: different operation "
 				     "in stmt ");
 		    dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
 				      stmts[i], 0);
-		    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		    vect_location_writeln (OPT_RECORD_FAILURE,
 				     "original stmt ");
 		    dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
 				      first_stmt, 0);
@@ -1258,7 +1259,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 		    vect_free_slp_tree (grandchild);
 		  SLP_TREE_CHILDREN (child).truncate (0);
 
-		  dump_printf_loc (MSG_NOTE, vect_location,
+		  vect_location_writeln (OPT_RECORD_REMARK,
 				   "Building parent vector operands from "
 				   "scalars instead\n");
 		  oprnd_info->def_stmts = vNULL;
@@ -1288,7 +1289,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 	     scalar version.  */
 	  && !is_pattern_stmt_p (vinfo_for_stmt (stmt)))
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "Building vector operands from scalars\n");
 	  child = vect_create_new_slp_node (oprnd_info->def_stmts);
 	  SLP_TREE_DEF_TYPE (child) = vect_external_def;
@@ -1344,7 +1345,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 		    {
 		      if (!swap_not_matching)
 			{
-			  if (dump_enabled_p ())
+			  if (thing_enabled_p ())
 			    {
 			      dump_printf_loc (MSG_MISSED_OPTIMIZATION,
 					       vect_location,
@@ -1363,7 +1364,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 	  while (j != group_size);
 
 	  /* Swap mismatched definition stmts.  */
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "Re-trying with swapped operands of stmts ");
 	  for (j = 0; j < group_size; ++j)
 	    if (matches[j] == !swap_not_matching)
@@ -1438,7 +1439,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 			vect_free_slp_tree (grandchild);
 		      SLP_TREE_CHILDREN (child).truncate (0);
 
-		      dump_printf_loc (MSG_NOTE, vect_location,
+		      vect_location_writeln (OPT_RECORD_REMARK,
 				       "Building parent vector operands from "
 				       "scalars instead\n");
 		      oprnd_info->def_stmts = vNULL;
@@ -1656,9 +1657,9 @@ vect_supported_load_permutation_p (slp_instance slp_instn)
   slp_tree node;
   gimple *stmt, *load, *next_load;
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "Load permutation ");
+      vect_location_writeln (OPT_RECORD_REMARK, "Load permutation ");
       FOR_EACH_VEC_ELT (SLP_INSTANCE_LOADS (slp_instn), i, node)
 	if (node->load_permutation.exists ())
 	  FOR_EACH_VEC_ELT (node->load_permutation, j, next)
@@ -1733,7 +1734,7 @@ vect_supported_load_permutation_p (slp_instance slp_instn)
 	      if (!TYPE_VECTOR_SUBPARTS (vectype).is_constant (&nunits)
 		  || maxk >= (GROUP_SIZE (group_info) & ~(nunits - 1)))
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  vect_location_writeln (OPT_RECORD_FAILURE,
 				   "BB vectorization with gaps at the end of "
 				   "a load is not supported\n");
 		  return false;
@@ -2114,8 +2115,8 @@ vect_split_slp_store_group (gimple *first_stmt, unsigned group1_size)
   /* GROUP_GAP of the first group now has to skip over the second group too.  */
   GROUP_GAP (first_vinfo) += group2_size;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location, "Split group into %d and %d\n",
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK, "Split group into %d and %d\n",
 		     group1_size, group2_size);
 
   return group2;
@@ -2172,9 +2173,9 @@ vect_analyze_slp_instance (vec_info *vinfo,
 
   if (!vectype)
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         {
-          dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          vect_location_writeln (OPT_RECORD_FAILURE,
 			   "Build SLP failed: unsupported data-type ");
           dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, scalar_type);
           dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -2238,8 +2239,8 @@ vect_analyze_slp_instance (vec_info *vinfo,
 	  if (!max_nunits.is_constant (&const_max_nunits)
 	      || const_max_nunits > group_size)
 	    {
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
 				 "Build SLP failed: store group "
 				 "size not a multiple of the vector size "
 				 "in basic block SLP\n");
@@ -2301,9 +2302,9 @@ vect_analyze_slp_instance (vec_info *vinfo,
         {
           if (!vect_supported_load_permutation_p (new_instance))
             {
-              if (dump_enabled_p ())
+              if (thing_enabled_p ())
                 {
-                  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+                  vect_location_writeln (OPT_RECORD_FAILURE,
 				   "Build SLP failed: unsupported load "
 				   "permutation ");
 		      dump_gimple_stmt (MSG_MISSED_OPTIMIZATION,
@@ -2336,8 +2337,8 @@ vect_analyze_slp_instance (vec_info *vinfo,
 	    }
 	  if (i == loads.length ())
 	    {
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
 				 "Built SLP cancelled: can use "
 				 "load/store-lanes\n");
 	      vect_free_slp_instance (new_instance);
@@ -2347,9 +2348,9 @@ vect_analyze_slp_instance (vec_info *vinfo,
 
       vinfo->slp_instances.safe_push (new_instance);
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "Final SLP tree for instance:\n");
 	  vect_print_slp_tree (MSG_NOTE, vect_location, node);
 	}
@@ -2415,8 +2416,8 @@ vect_analyze_slp (vec_info *vinfo, unsigned max_tree_size)
   unsigned int i;
   gimple *first_element;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location, "=== vect_analyze_slp ===\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK, "=== vect_analyze_slp ===\n");
 
   /* Find SLP sequences starting from groups of grouped stores.  */
   FOR_EACH_VEC_ELT (vinfo->grouped_stores, i, first_element)
@@ -2469,8 +2470,8 @@ vect_make_slp_decision (loop_vec_info loop_vinfo)
   slp_instance instance;
   int decided_to_slp = 0;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location, "=== vect_make_slp_decision ==="
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK, "=== vect_make_slp_decision ==="
                      "\n");
 
   FOR_EACH_VEC_ELT (slp_instances, i, instance)
@@ -2491,9 +2492,9 @@ vect_make_slp_decision (loop_vec_info loop_vinfo)
 
   LOOP_VINFO_SLP_UNROLLING_FACTOR (loop_vinfo) = unrolling_factor;
 
-  if (decided_to_slp && dump_enabled_p ())
+  if (decided_to_slp && thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
+      vect_location_writeln (OPT_RECORD_REMARK,
 		       "Decided to SLP %d instances. Unrolling factor ",
 		       decided_to_slp);
       dump_dec (MSG_NOTE, unrolling_factor);
@@ -2553,9 +2554,9 @@ vect_detect_hybrid_slp_stmts (slp_tree node, unsigned i, slp_vect_type stype)
 		&& !(gimple_code (use_stmt) == GIMPLE_PHI
 		     && STMT_VINFO_DEF_TYPE (use_vinfo) == vect_reduction_def))
 	      {
-		if (dump_enabled_p ())
+		if (thing_enabled_p ())
 		  {
-		    dump_printf_loc (MSG_NOTE, vect_location, "use of SLP "
+		    vect_location_writeln (OPT_RECORD_REMARK, "use of SLP "
 				     "def in non-SLP stmt: ");
 		    dump_gimple_stmt (MSG_NOTE, TDF_SLIM, use_stmt, 0);
 		  }
@@ -2567,9 +2568,9 @@ vect_detect_hybrid_slp_stmts (slp_tree node, unsigned i, slp_vect_type stype)
   if (stype == hybrid
       && !HYBRID_SLP_STMT (stmt_vinfo))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location, "marking hybrid: ");
+	  vect_location_writeln (OPT_RECORD_REMARK, "marking hybrid: ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	}
       STMT_SLP_TYPE (stmt_vinfo) = hybrid;
@@ -2598,9 +2599,9 @@ vect_detect_hybrid_slp_1 (tree *tp, int *, void *data)
       if (flow_bb_inside_loop_p (loopp, gimple_bb (def_stmt))
 	  && PURE_SLP_STMT (vinfo_for_stmt (def_stmt)))
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location, "marking hybrid: ");
+	      vect_location_writeln (OPT_RECORD_REMARK, "marking hybrid: ");
 	      dump_gimple_stmt (MSG_NOTE, TDF_SLIM, def_stmt, 0);
 	    }
 	  STMT_SLP_TYPE (vinfo_for_stmt (def_stmt)) = hybrid;
@@ -2637,8 +2638,8 @@ vect_detect_hybrid_slp (loop_vec_info loop_vinfo)
   vec<slp_instance> slp_instances = LOOP_VINFO_SLP_INSTANCES (loop_vinfo);
   slp_instance instance;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location, "=== vect_detect_hybrid_slp ==="
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK, "=== vect_detect_hybrid_slp ==="
                      "\n");
 
   /* First walk all pattern stmt in the loop and mark defs of uses as
@@ -2762,9 +2763,9 @@ vect_slp_analyze_node_operations (vec_info *vinfo, slp_tree node,
       gcc_assert (PURE_SLP_STMT (stmt_info));
 
       tree scalar_type = TREE_TYPE (gimple_get_lhs (stmt));
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "get vectype for scalar type:  ");
 	  dump_generic_expr (MSG_NOTE, TDF_SLIM, scalar_type);
 	  dump_printf (MSG_NOTE, "\n");
@@ -2773,9 +2774,9 @@ vect_slp_analyze_node_operations (vec_info *vinfo, slp_tree node,
       tree vectype = get_vectype_for_scalar_type (scalar_type);
       if (!vectype)
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      vect_location_writeln (OPT_RECORD_FAILURE,
 			       "not SLPed: unsupported data-type ");
 	      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
 				 scalar_type);
@@ -2784,9 +2785,9 @@ vect_slp_analyze_node_operations (vec_info *vinfo, slp_tree node,
 	  return false;
 	}
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location, "vectype:  ");
+	  vect_location_writeln (OPT_RECORD_REMARK, "vectype:  ");
 	  dump_generic_expr (MSG_NOTE, TDF_SLIM, vectype);
 	  dump_printf (MSG_NOTE, "\n");
 	}
@@ -2846,8 +2847,8 @@ vect_slp_analyze_operations (vec_info *vinfo)
   slp_instance instance;
   int i;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
 		     "=== vect_slp_analyze_operations ===\n");
 
   for (i = 0; vinfo->slp_instances.iterate (i, &instance); )
@@ -2856,7 +2857,7 @@ vect_slp_analyze_operations (vec_info *vinfo)
 					     SLP_INSTANCE_TREE (instance),
 					     instance))
         {
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "removing SLP instance operations starting from: ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM,
 			    SLP_TREE_SCALAR_STMTS
@@ -2868,8 +2869,8 @@ vect_slp_analyze_operations (vec_info *vinfo)
 	i++;
     }
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
 		     "=== vect_analyze_slp_cost ===\n");
 
   /* Compute the costs of the SLP instances.  */
@@ -2994,9 +2995,9 @@ vect_bb_vectorization_profitable_p (bb_vec_info bb_vinfo)
 
   vec_outside_cost = vec_prologue_cost + vec_epilogue_cost;
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "Cost model analysis: \n");
+      vect_location_writeln (OPT_RECORD_REMARK, "Cost model analysis: \n");
       dump_printf (MSG_NOTE, "  Vector inside of basic block cost: %d\n",
 		   vec_inside_cost);
       dump_printf (MSG_NOTE, "  Vector prologue cost: %d\n", vec_prologue_cost);
@@ -3035,8 +3036,8 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
 
   if (n_stmts > PARAM_VALUE (PARAM_SLP_MAX_INSNS_IN_BB))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "not vectorized: too many instructions in "
 			 "basic block.\n");
       free_data_refs (datarefs);
@@ -3053,8 +3054,8 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
 
   if (!vect_analyze_data_refs (bb_vinfo, &min_vf))
     {
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_FAILURE,
 			 "not vectorized: unhandled data-ref in basic "
 			 "block.\n");
 
@@ -3064,8 +3065,8 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
 
   if (BB_VINFO_DATAREFS (bb_vinfo).length () < 2)
     {
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_FAILURE,
 			 "not vectorized: not enough data-refs in "
 			 "basic block.\n");
 
@@ -3075,8 +3076,8 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
 
   if (!vect_analyze_data_ref_accesses (bb_vinfo))
     {
-     if (dump_enabled_p ())
-       dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+     if (thing_enabled_p ())
+       vect_location_writeln (OPT_RECORD_FAILURE,
 			"not vectorized: unhandled data access in "
 			"basic block.\n");
 
@@ -3089,8 +3090,8 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
      anyway.  */
   if (bb_vinfo->grouped_stores.is_empty ())
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "not vectorized: no grouped stores in "
 			 "basic block.\n");
 
@@ -3107,11 +3108,11 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
      trees.  */
   if (!vect_analyze_slp (bb_vinfo, n_stmts))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 			   "Failed to SLP the basic block.\n");
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location, 
+	  vect_location_writeln (OPT_RECORD_FAILURE, 
 			   "not vectorized: failed to find SLP opportunities "
 			   "in basic block.\n");
 	}
@@ -3129,7 +3130,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
       if (! vect_slp_analyze_and_verify_instance_alignment (instance)
 	  || ! vect_slp_analyze_instance_dependence (instance))
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "removing SLP instance operations starting from: ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM,
 			    SLP_TREE_SCALAR_STMTS
@@ -3154,8 +3155,8 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
 
   if (!vect_slp_analyze_operations (bb_vinfo))
     {
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_FAILURE,
 			 "not vectorized: bad operation in basic block.\n");
 
       delete bb_vinfo;
@@ -3166,8 +3167,8 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
   if (!unlimited_cost_model (NULL)
       && !vect_bb_vectorization_profitable_p (bb_vinfo))
     {
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_FAILURE,
 			 "not vectorized: vectorization is not "
 			 "profitable.\n");
 
@@ -3175,8 +3176,8 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
       return NULL;
     }
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
 		     "Basic block will be vectorized using SLP\n");
 
   return bb_vinfo;
@@ -3194,8 +3195,8 @@ vect_slp_bb (basic_block bb)
   bool any_vectorized = false;
   auto_vector_sizes vector_sizes;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location, "===vect_slp_analyze_bb===\n");
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK, "===vect_slp_analyze_bb===\n");
 
   /* Autodetect first vector size we try.  */
   current_vector_size = 0;
@@ -3222,7 +3223,10 @@ vect_slp_bb (basic_block bb)
 	  insns++;
 
 	  if (gimple_location (stmt) != UNKNOWN_LOCATION)
-	    vect_location = gimple_location (stmt);
+	    {
+	      vect_location = gimple_location (stmt);
+	      vect_location_thing = stmt;
+	    }
 
 	  if (!find_data_references_in_stmt (NULL, stmt, &datarefs))
 	    break;
@@ -3244,13 +3248,13 @@ vect_slp_bb (basic_block bb)
       if (bb_vinfo
 	  && dbg_cnt (vect_slp))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_NOTE, vect_location, "SLPing BB part\n");
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_REMARK, "SLPing BB part\n");
 
 	  vect_schedule_slp (bb_vinfo);
 
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_REMARK,
 			     "basic block part vectorized\n");
 
 	  vectorized = true;
@@ -3287,9 +3291,9 @@ vect_slp_bb (basic_block bb)
 	{
 	  /* Try the next biggest vector size.  */
 	  current_vector_size = vector_sizes[next_size++];
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 			       "***** Re-trying analysis with "
 			       "vector size ");
 	      dump_dec (MSG_NOTE, current_vector_size);
@@ -3951,11 +3955,12 @@ vect_transform_slp_perm_load (slp_tree node, vec<tree> dr_chain,
 	    }
 	  else
 	    {
-	      if (dump_enabled_p ())
+	      if (thing_enabled_p ())
 		{
-		  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
-				   "permutation requires at "
-				   "least three vectors ");
+		  // FIXME: would be better to use "stmt" for location here:
+		  vect_location_writeln (OPT_RECORD_FAILURE,
+					 "permutation requires at "
+					 "least three vectors ");
 		  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
 				    stmt, 0);
 		}
@@ -3973,7 +3978,7 @@ vect_transform_slp_perm_load (slp_tree node, vec<tree> dr_chain,
 	      indices.new_vector (mask, 2, nunits);
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
-		  if (dump_enabled_p ())
+		  if (thing_enabled_p ())
 		    {
 		      dump_printf_loc (MSG_MISSED_OPTIMIZATION,
 				       vect_location, 
@@ -4093,7 +4098,7 @@ vect_schedule_slp_instance (slp_tree node, slp_instance instance,
   if (!SLP_TREE_VEC_STMTS (node).exists ())
     SLP_TREE_VEC_STMTS (node).create (SLP_TREE_NUMBER_OF_VEC_STMTS (node));
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
       dump_printf_loc (MSG_NOTE,vect_location,
 		       "------>vectorizing SLP node starting from: ");
